var fs = require("fs"),
    jsdom  = require("jsdom");

/**
	takes some html, ssjquery, and json and output processed html.

*/
exports.bakeHtml = function (jsonFile, serverJsFiles, htmlFile, outPutFunc, includeJSON) {

	var htmlData = fs.readFileSync(htmlFile).toString(),
	    jsonData = fs.readFileSync(jsonFile).toString();

	var serverJson = 'window._jsonData = ' + jsonData + ";";
	var jsDataString = serverJson + "\n";

	for(var i = 0; i < serverJsFiles.length; i += 1) {
		jsDataString += fs.readFileSync(serverJsFiles[i]).toString();
	}
	var javaScripts = [jsDataString];


	jsdom.env({
		html: htmlData,
		src: javaScripts,
		done: function(errors, window) {
			var outputHtml = window.document.outerHTML;
			var docType = window.document.doctype + '';


			//HACK: since the doc type is not output, we add it in here.
			outputHtml = (docType + "\n") + outputHtml;

			if(includeJSON === true) {
				// Add server side json into the output html.
				var addServerJson = "<script type='text/javascript'>\nwindow._jsonData = " +  jsonData + ";\n</script>\n";
				//HACK: since the above .append does not work, we hack it in here.
				outputHtml = outputHtml.replace('<head>', "<head>\n<script type='text/javascript'>\nwindow._processedServerSide = true;\n</script>\n" + addServerJson);
			}
			outPutFunc(outputHtml);
		}
	});
};

